<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeriesContratosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeriesContratosERP
 * @subpackage Arrays
 */
class ArrayOfSeriesContratosERP extends AbstractStructArrayBase
{
    /**
     * The SeriesContratosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeriesContratosERP[]
     */
    public $SeriesContratosERP;
    /**
     * Constructor method for ArrayOfSeriesContratosERP
     * @uses ArrayOfSeriesContratosERP::setSeriesContratosERP()
     * @param \StructType\SeriesContratosERP[] $seriesContratosERP
     */
    public function __construct(array $seriesContratosERP = array())
    {
        $this
            ->setSeriesContratosERP($seriesContratosERP);
    }
    /**
     * Get SeriesContratosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeriesContratosERP[]|null
     */
    public function getSeriesContratosERP()
    {
        return isset($this->SeriesContratosERP) ? $this->SeriesContratosERP : null;
    }
    /**
     * Set SeriesContratosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeriesContratosERP[] $seriesContratosERP
     * @return \ArrayType\ArrayOfSeriesContratosERP
     */
    public function setSeriesContratosERP(array $seriesContratosERP = array())
    {
        foreach ($seriesContratosERP as $arrayOfSeriesContratosERPSeriesContratosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeriesContratosERPSeriesContratosERPItem instanceof \StructType\SeriesContratosERP) {
                throw new \InvalidArgumentException(sprintf('The SeriesContratosERP property can only contain items of \StructType\SeriesContratosERP, "%s" given', is_object($arrayOfSeriesContratosERPSeriesContratosERPItem) ? get_class($arrayOfSeriesContratosERPSeriesContratosERPItem) : gettype($arrayOfSeriesContratosERPSeriesContratosERPItem)), __LINE__);
            }
        }
        if (is_null($seriesContratosERP) || (is_array($seriesContratosERP) && empty($seriesContratosERP))) {
            unset($this->SeriesContratosERP);
        } else {
            $this->SeriesContratosERP = $seriesContratosERP;
        }
        return $this;
    }
    /**
     * Add item to SeriesContratosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\SeriesContratosERP $item
     * @return \ArrayType\ArrayOfSeriesContratosERP
     */
    public function addToSeriesContratosERP(\StructType\SeriesContratosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeriesContratosERP) {
            throw new \InvalidArgumentException(sprintf('The SeriesContratosERP property can only contain items of \StructType\SeriesContratosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SeriesContratosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeriesContratosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeriesContratosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeriesContratosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeriesContratosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeriesContratosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeriesContratosERP
     */
    public function getAttributeName()
    {
        return 'SeriesContratosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSeriesContratosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
